/**************************************************************************/
/*-                                                                      -*/
/*-                                                                      -*/
/*-                         elFPSNX									  -*/
/*-                                                                      -*/
/*-                                                                      -*/
/*-              elŃt[[gŒ肳邽߂̃NX              -*/
/*-                                                                      -*/
/*-                                                                      -*/
/*-                             Ft`                             -*/
/*-                                                                      -*/
/*-                                                                      -*/
/**************************************************************************/


/**********************************************/
/*-          XN[`          -*/
/**********************************************/
#undef	elSetScreen
#define elSetScreen(a,b)					\
	case (a):								\
		{									\
			(b);							\
			elFPS::CheckFrameRate();		\
			break;							\
		}

/**********************************************/
/*-         t[[gǗNX         -*/
/**********************************************/
class elFPS
{
private:
	static bool Active;
	static unsigned long OneFrameTime;
	static unsigned long OldFrameTime;
	static unsigned long FrameRate;

public:
	static bool SetFrameRate( unsigned long frame );
	static bool CheckFrameRate( void );
	static void SetActive( bool flag ) { Active = flag; elDraw::SetRefreshMode( !flag ); }

};

bool elFPS::Active = false;
unsigned long elFPS::OneFrameTime;
unsigned long elFPS::OldFrameTime;
unsigned long elFPS::FrameRate;

/**********************************************/
/*-  ^C}[xグ邽߂̃_~[NX  -*/
/**********************************************/
class _elFPSDummy
{
public:
	_elFPSDummy::_elFPSDummy()
	{
		timeBeginPeriod( 1 );
		elFPS::SetFrameRate( 60 );
		elFPS::SetActive( true );
	}
	_elFPSDummy::~_elFPSDummy()
	{
		timeEndPeriod( 1 );
	}

} elFPSDummy;

/**************************************************************************/
/*-                                                                      -*/
/*-                       t[[g̐ݒ                           -*/
/*-                                                                      -*/
/*-                   framerate : bԂ̃t[                       -*/
/*-                                                                      -*/
/**************************************************************************/
bool elFPS::SetFrameRate( unsigned long rate )
{
	FrameRate = rate;

	// 1t[̎Ԃ擾
	OneFrameTime = (1000 / FrameRate);
	// p
	OldFrameTime = timeGetTime();

	return true;
}

/**************************************************************************/
/*-                                                                      -*/
/*-                       t[[g̃`FbN                       -*/
/*-                                                                      -*/
/*-                   Ԃl : true̎Ԍo                            -*/
/*-                                                                      -*/
/**************************************************************************/
bool elFPS::CheckFrameRate( void )
{
	if ( !Active ) return true;

	unsigned long now = timeGetTime();
	long time = now - OldFrameTime;
	long wait = OneFrameTime - time -3;
	Sleep( ( (wait>0)?(wait):(0) ) );

	while ( true )
	{
		if ( time >= OneFrameTime )
		{
			OldFrameTime = now;
			FrameTime = (float)( now - OldFrameTime ) / 1000.0f;
			break;
		}
		now = timeGetTime();
		time = now - OldFrameTime;
	}
	return true;
}
